library verilog;
use verilog.vl_types.all;
entity EPT_5M57_AP_U2_Top is
    generic(
        TRANSFER_CONTROL_BYTE1: vl_logic_vector(0 to 7) := (Hi0, Hi1, Hi0, Hi1, Hi1, Hi0, Hi1, Hi0);
        TRANSFER_CONTROL_BYTE2: vl_logic_vector(0 to 7) := (Hi1, Hi1, Hi0, Hi0, Hi0, Hi0, Hi1, Hi1);
        TRANSFER_CONTROL_BYTE3: vl_logic_vector(0 to 7) := (Hi0, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1, Hi0);
        TRANSFER_CONTROL_IDLE: integer := 0;
        TRANSFER_CONTROL_HDR1: integer := 1;
        TRANSFER_CONTROL_HDR2: integer := 2;
        TRANSFER_DECODE_BYTE: integer := 3;
        TRANSFER_CONTROL_SET: integer := 4;
        GLOBAL_RESET_COUNT: vl_logic_vector(0 to 5) := (Hi1, Hi1, Hi1, Hi0, Hi0, Hi0);
        TRANSFER_HOST_IDLE: integer := 1;
        TRANSFER_HOST_LOOPBACK_START: integer := 2;
        TRANSFER_HOST_LOOPBACK_COMPLETE: integer := 3;
        BLOCK_LOOPBACK_IDLE: integer := 1;
        BLOCK_LOOPBACK_INIT: integer := 2;
        FIFO_EN_HIGH    : integer := 3;
        FIFO_EN_LOW     : integer := 4;
        BLK_TRANSFER_OUT_IDLE: integer := 1;
        BLK_TRANSFER_OUT_COUNT: integer := 2;
        LED_COUNT       : vl_logic_vector(0 to 23) := (Hi0, Hi1, Hi1, Hi0, Hi0, Hi1, Hi0, Hi0, Hi1, Hi0, Hi1, Hi1, Hi0, Hi1, Hi0, Hi1, Hi0, Hi1, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0)
    );
    port(
        aa              : in     vl_logic_vector(1 downto 0);
        bc_in           : in     vl_logic_vector(1 downto 0);
        bc_out          : out    vl_logic_vector(2 downto 0);
        bd_inout        : inout  vl_logic_vector(7 downto 0);
        LB_SER          : inout  vl_logic_vector(1 downto 0);
        LB_AD           : in     vl_logic_vector(5 downto 0);
        LB_IOH          : in     vl_logic_vector(7 downto 0);
        LB_IOL          : in     vl_logic_vector(7 downto 0);
        TR_DIR_1        : out    vl_logic;
        TR_OE_1         : out    vl_logic;
        TR_DIR_2        : out    vl_logic;
        TR_OE_2         : out    vl_logic;
        TR_DIR_3        : out    vl_logic;
        TR_OE_3         : out    vl_logic;
        SW_USER_1       : in     vl_logic;
        SW_USER_2       : in     vl_logic;
        LED             : out    vl_logic_vector(3 downto 0)
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_BYTE1 : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_BYTE2 : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_BYTE3 : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_IDLE : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_HDR1 : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_HDR2 : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_DECODE_BYTE : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_CONTROL_SET : constant is 1;
    attribute mti_svvh_generic_type of GLOBAL_RESET_COUNT : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_HOST_IDLE : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_HOST_LOOPBACK_START : constant is 1;
    attribute mti_svvh_generic_type of TRANSFER_HOST_LOOPBACK_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of BLOCK_LOOPBACK_IDLE : constant is 1;
    attribute mti_svvh_generic_type of BLOCK_LOOPBACK_INIT : constant is 1;
    attribute mti_svvh_generic_type of FIFO_EN_HIGH : constant is 1;
    attribute mti_svvh_generic_type of FIFO_EN_LOW : constant is 1;
    attribute mti_svvh_generic_type of BLK_TRANSFER_OUT_IDLE : constant is 1;
    attribute mti_svvh_generic_type of BLK_TRANSFER_OUT_COUNT : constant is 1;
    attribute mti_svvh_generic_type of LED_COUNT : constant is 1;
end EPT_5M57_AP_U2_Top;
